/*
 * (C) 2007-2012 Alibaba Group Holding Limited.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * Authors:
 *   wuhua <wq163@163.com> , boyan <killme2008@gmail.com>
 */
package com.taobao.metamorphosis.client.producer;

import java.util.concurrent.TimeUnit;

import com.taobao.metamorphosis.Message;
import com.taobao.metamorphosis.client.Shutdownable;
import com.taobao.metamorphosis.exception.MetaClientException;


/**
 * Ϣߣ̰߳ȫƼ
 * 
 * @author boyan
 * @Date 2011-4-21
 * 
 */
public interface MessageProducer extends Shutdownable {

    /**
     * topicԱproducerzookeeperȡbrokerбӣڷϢǰȵô˷
     * 
     * @param topic
     */
    public void publish(String topic);


    /**
     * ÷ϢĬtopic͵messagetopicûҵbrokerͷʱѡĬtopicָbroker
     * ñԶpublishtopic
     * 
     * @param topic
     */
    public void setDefaultTopic(String topic);


    /**
     * Ϣ
     * 
     * @param message
     *            Ϣ
     * 
     * @return ͽ
     * @throws MetaClientException
     *             ͻ쳣
     * @throws InterruptedException
     *             Ӧж
     */
    public SendResult sendMessage(Message message) throws MetaClientException, InterruptedException;


    /**
     * 첽Ϣָʱڻصcallback,ģʽ޷ʹ
     * 
     * @param message
     * @param cb
     * @param time
     * @param unit
     * @since 1.4
     */
    public void sendMessage(Message message, SendMessageCallback cb, long time, TimeUnit unit);


    /**
     * 첽ϢĬʱڣ3룩صcallbackģʽ޷ʹ
     * 
     * @param message
     * @param cb
     * @since 1.4
     */
    public void sendMessage(Message message, SendMessageCallback cb);


    /**
     * Ϣ,ָʱûзأ׳쳣
     * 
     * @param message
     *            Ϣ
     * @param timeout
     *            ʱʱ
     * @param unit
     *            ʱʱ䵥λ
     * @return ͽ
     * @throws MetaClientException
     *             ͻ쳣
     * @throws InterruptedException
     *             Ӧж
     */
    public SendResult sendMessage(Message message, long timeout, TimeUnit unit) throws MetaClientException,
    InterruptedException;


    /**
     * رߣͷԴ
     */
    @Override
    public void shutdown() throws MetaClientException;


    /**
     * رߵķѡ
     * 
     * @return
     */
    public PartitionSelector getPartitionSelector();


    /**
     * ر߷ϢǷ,ָͬһpartitionϢ򡣴˷ѾǷfalse
     * 
     * @return trueʾ
     */
    @Deprecated
    public boolean isOrdered();


    /**
     * һ񲢹ǰ̣߳ڷ͵ϢΪһԪύҪôȫͳɹҪôȫʧ
     * 
     * @throws MetaClientException
     *             ѾУ׳TransactionInProgressException쳣
     */
    public void beginTransaction() throws MetaClientException;


    /**
     * ʱʱ䣬ʼʱ趨ʱ仹ûύ߻ع˽ع
     * 
     * @param seconds
     *            ʱʱ䣬λ
     * @throws MetaClientException
     * @see #beginTransaction()
     * @see #rollback()
     * @see #commit()
     */
    public void setTransactionTimeout(int seconds) throws MetaClientException;


    /**
     * Set transaction command request timeout.default is five seconds.
     * 
     * @param time
     * @param timeUnit
     */
    public void setTransactionRequestTimeout(long time, TimeUnit timeUnit);


    /**
     * صǰõʱʱ䣬ĬΪ0,ʾʱ
     * 
     * @return ʱʱ䣬λ
     * @throws MetaClientException
     */
    public int getTransactionTimeout() throws MetaClientException;


    /**
     * عǰ͵κϢ˷beginTransaction֮
     * 
     * @throws MetaClientException
     * @see #beginTransaction()
     */
    public void rollback() throws MetaClientException;


    /**
     * ύǰ񣬽ڷ͵Ϣ־û˷beginTransaction֮
     * 
     * @see #beginTransaction()
     * @throws MetaClientException
     */
    public void commit() throws MetaClientException;

}